<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class OpeningBlock extends Record {
    /**
     * @var string Logon do usuário na API do Serasa
     */
    private $logon;

    /**
     * @var string Senha do usuário na API do Serasa
     */
    private $password;

    /**
     * @var string Espaços
     */
    private $blank;

    public function __construct($logon, $password) {
        $this->setValues($logon, $password);
        $this->setColumns();
    }

    /**
     * Define os valores dos campos
     */
    private function setValues($logon, $password) {
        $this->logon = $logon;
        $this->password = $password;
        $this->blank = "";
    }

    /**
     * Define as colunas manualmente
     */
    private function setColumns() {
        $this->setColumn("logon", new RecordColumn($this->logon, RecordColumn::TYPE_ALPHANUMERIC, 1, 8));
        $this->setColumn("password", new RecordColumn($this->password, RecordColumn::TYPE_ALPHANUMERIC, 9, 8));
        $this->setColumn("blank", new RecordColumn($this->blank, RecordColumn::TYPE_ALPHANUMERIC, 17, 8));
    }
}