<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegN001 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = [
        [
            'name' => 'type_rule',
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 1, 
            'size' => 4
        ],

        [
            'name' => "subtp", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 5, 
            'size' => 2
        ],

        [
            'name' => "tp_cons", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 7, 
            'size' => 2
        ],

        [
            'name' => "trans_cons", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 9, 
            'size' => 4
        ],

        [
            'name' => "sol_gde_var", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 13, 
            'size' => 1
        ],

        [
            'name' => "id_cheque", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 14, 
            'size' => 1
        ],

        [
            'name' => "agrupa", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 15, 
            'size' => 1
        ],

        [
            'name' => "cons_sint", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 16, 
            'size' => 1
        ],

        [
            'name' => "reservado", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 17, 
            'size' => 1
        ],

        [
            'name' => "anot_resum", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 18, 
            'size' => 1
        ],

        [
            'name' => "chave_cons", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 19, 
            'size' => 6
        ],

        [
            'name' => "fantasia", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 25, 
            'size' => 12
        ],

        [
            'name' => "status_bco", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 37, 
            'size' => 1
        ],

        [
            'name' => "blank_1", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 38, 
            'size' => 13
        ],

        [
            'name' => "trata_tel", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 51, 
            'size' => 1
        ],

        [
            'name' => "blank_2", 
            'type' => RecordColumn::TYPE_ALPHANUMERIC,
            'position' => 52, 
            'size' => 64
        ]

    ];


    public function __construct($values = null) {
        $this->createColumns();

        if($values !== null) {
            $this->setValues($values);
        }
    }

    /**
     * Define os valores dos campos
     * @param array $values
     */
    private function setValues($values) {
        $values['type_rule'] = "N001";
        $values['subtp'] = "00";
        $values['tp_cons'] = "PP";
        $values['trans_cons'] = "BPCB";
        $values['sol_gde_var'] = "N";
        $values['id_cheque'] = "0";
        $values['agrupa'] = "N";
        $values['cons_sint'] = "";
        $values['reservado'] = "";
        $values['anot_resum'] = "";
        $values['chave_cons'] = "";
        $values['fantasia'] = "";
        $values['status_bco'] = "";
        $values['blank_1'] = "";
        $values['trata_tel'] = "S";
        $values['blank_2'] = "";

        $this->setColumnsValues($values);
    }
}