<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN240_01 extends Record{
    public $name = "financial_issues_detail_complement";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "subjudice",
            'position' => 7,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "msg_subj",
            'position' => 8,
            'size' => 76,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tp_anotation",
            'position' => 84,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 85,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 95,
            'size' => 21,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['subjudice'] = substr($values, 6, 1);
        $newValues['msg_subj'] = substr($values, 7, 76);
        $newValues['tp_anotation'] = substr($values, 83, 1);
        $newValues['filler'] = substr($values, 84, 10);
        $newValues['filler'] = substr($values, 94, 21);
        
        $this->setColumnsValues($newValues);
    }
}