<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN710_00 extends Record {
    public $name = "partner_participation";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "doc",
            'position' => 7,
            'size' => 14,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "nome",
            'position' => 21,
            'size' => 70,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cidade",
            'position' => 91,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 111,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 113,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ]
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['doc'] = substr($values, 6, 14);
        $newValues['nome'] = substr($values, 20, 70);
        $newValues['cidade'] = substr($values, 90, 20);
        $newValues['uf'] = substr($values, 110, 2);
        $newValues['filler'] = substr($values, 112, 3);
        
        $this->setColumnsValues($newValues);
    }   
}